package imap

import (
	"log"
	"time"

	"github.com/emersion/go-imap"

	"ur.gs/crockery/internal/store"
)

var (
	InboxName = imap.InboxName
)

type Mailbox struct {
	stored  store.Mailbox
	session *Session
}

// Name returns this mailbox name.
func (m *Mailbox) Name() string {
	return m.stored.Name
}

// Info returns this mailbox info.
func (m *Mailbox) Info() (*imap.MailboxInfo, error) {
	log.Printf("Mailbox(%v).Info()", m.stored.ID)
	return &imap.MailboxInfo{
		Attributes: []string{}, // FIXME: what do we need here?
		Delimiter:  ".",
		Name:       m.Name(),
	}, nil
}

// Status returns this mailbox status. The fields Name, Flags, PermanentFlags
// and UnseenSeqNum in the returned MailboxStatus must be always populated.
// This function does not affect the state of any messages in the mailbox. See
// RFC 3501 section 6.3.10 for a list of items that can be requested.
func (m *Mailbox) Status(items []string) (*imap.MailboxStatus, error) {
	log.Printf("Mailbox(%v).Status(%#v)", m.stored.ID, items)

	return &imap.MailboxStatus{
		Name:           m.Name(),
		Flags:          []string{}, // FIXME: what do we need here?
		PermanentFlags: []string{}, // FIXME: what do we need here?
		//UnseenSeqNum: 0, // FIXME: what do we need here? What even is a seqnum?
		Messages: 1, // FIXME: hardcoded
	}, nil
}

// SetSubscribed adds or removes the mailbox to the server's set of "active"
// or "subscribed" mailboxes.
func (m *Mailbox) SetSubscribed(subscribed bool) error {
	log.Printf("Mailbox(%v).SetSubscribed(%#v): not implemented", m.stored.ID, subscribed)
	return ErrNotImplemented
}

// Check requests a checkpoint of the currently selected mailbox. A checkpoint
// refers to any implementation-dependent housekeeping associated with the
// mailbox (e.g., resolving the server's in-memory state of the mailbox with
// the state on its disk). A checkpoint MAY take a non-instantaneous amount of
// real time to complete. If a server implementation has no such housekeeping
// considerations, CHECK is equivalent to NOOP.
func (m *Mailbox) Check() error {
	log.Printf("Mailbox(%v).Check()", m.stored.ID)
	return nil // FIXME: do we need to do anything here?
}

// ListMessages returns a list of messages. seqset must be interpreted as UIDs
// if uid is set to true and as message sequence numbers otherwise. See RFC
// 3501 section 6.4.5 for a list of items that can be requested.
//
// Messages must be sent to ch. When the function returns, ch must be closed.
func (m *Mailbox) ListMessages(uid bool, seqset *imap.SeqSet, items []string, ch chan<- *imap.Message) error {
	log.Printf("Mailbox(%v).ListMessages(%#v, %#v, %#v, ch)", m.stored.ID, uid, *seqset, items)
	defer close(ch)

	var messages []store.Message
	for _, set := range seqset.Set {
		msgs, err := m.session.store.FindMessagesInRange(
			m.stored, uint64(set.Start), uint64(set.Stop),
		)

		if err != nil && !store.IsNotFound(err) {
			log.Printf("	error: %#v", err)
			return err
		}

		messages = append(messages, msgs...)
	}

	log.Printf("	%v messages: %#v", len(messages), messages)
	for _, message := range messages {
		envelope := &imap.Envelope{
			// Date:
			Subject: message.Header.Get("Subject"),
			// From:
			// Sender:
			// ReplyTo:
			// To:
			// Cc:
			// Bcc:
			InReplyTo: message.Header.Get("In-Reply-To"),
			MessageId: message.Header.Get("Message-Id"),
		}

		body := map[*imap.BodySectionName]imap.Literal{}

		imapMsg := imap.NewMessage(uint32(message.ID), items)
		fillItems(imapMsg, message)
		imapMsg.Envelope = envelope
		imapMsg.Body = body
		imapMsg.Uid = uint32(message.ID)
		imapMsg.Size = uint32(len(message.EML))

		log.Printf("	Sending message %#v", imapMsg)
		ch <- imapMsg
		log.Printf("	Sent message")
	}

	return nil
}

func fillItems(imapMsg *imap.Message, msg store.Message) {
	for k, _ := range imapMsg.Items {
		switch k {
		case "UID":
			imapMsg.Items[k] = msg.ID
		case "FLAGS":
			imapMsg.Items[k] = []string{}
		case "RFC822.SIZE":
			imapMsg.Items[k] = uint32(len(msg.EML))
		// FIXME: Actually send *just* the header...
		case "RFC822.HEADER":
			imapMsg.Items[k] = string(msg.EML)
		default:
			log.Printf("Unknown item: %v", k)
		}
	}
}

// SearchMessages searches messages. The returned list must contain UIDs if
// uid is set to true, or sequence numbers otherwise.
func (m *Mailbox) SearchMessages(uid bool, criteria *imap.SearchCriteria) ([]uint32, error) {
	log.Printf("Mailbox(%v).SearchMessages(): not implemented", m.stored.ID)
	return nil, ErrNotImplemented
}

// CreateMessage appends a new message to this mailbox. The \Recent flag will
// be added no matter flags is empty or not. If date is nil, the current time
// will be used.
//
// If the Backend implements Updater, it must notify the client immediately
// via a mailbox update.
func (m *Mailbox) CreateMessage(flags []string, date time.Time, body imap.Literal) error {
	log.Printf("Mailbox(%v).CreateMessage(%#v %#v %#v): not implemented", m.stored.ID, flags, date, body)
	return ErrNotImplemented
}

// UpdateMessagesFlags alters flags for the specified message(s).
//
// If the Backend implements Updater, it must notify the client immediately
// via a message update.
func (m *Mailbox) UpdateMessagesFlags(uid bool, seqset *imap.SeqSet, operation imap.FlagsOp, flags []string) error {
	log.Printf("Mailbox(%v).UpdateMessagesFlags(...): not implemented", m.stored.ID)
	return ErrNotImplemented
}

// CopyMessages copies the specified message(s) to the end of the specified
// destination mailbox. The flags and internal date of the message(s) SHOULD
// be preserved, and the Recent flag SHOULD be set, in the copy.
//
// If the destination mailbox does not exist, a server SHOULD return an error.
// It SHOULD NOT automatically create the mailbox.
//
// If the Backend implements Updater, it must notify the client immediately
// via a mailbox update.
func (m *Mailbox) CopyMessages(uid bool, seqset *imap.SeqSet, dest string) error {
	log.Printf("Mailbox(%v).CopyMessages(...): not implemented", m.stored.ID)
	return ErrNotImplemented
}

// Expunge permanently removes all messages that have the \Deleted flag set
// from the currently selected mailbox.
//
// If the Backend implements Updater, it must notify the client immediately
// via an expunge update.
func (m *Mailbox) Expunge() error {
	log.Printf("Mailbox(%v).CopyMessages(): not implemented", m.stored.ID)
	return ErrNotImplemented
}
